#!/bin/bash
#2021/08/19 v1.0
# Автор Мамзиков Артём Андреевич Описание по скрипту
# Получение списка Физических Логических дисков

#./net.if.sh 192.168.ххх.ххх discovery 10050, ключ disk.spisok.sh[{HOST.CONN},discovery,{HOST.PORT}]
# {HOST.HOST} -Имя узла сети; {HOST.CONN} -IP адрес или DNS имя узла сети; {HOST.PORT} -Порт узла сети (агента)

if [[ $2 = "discovery.physical" ]]
then

# Список Физический/Логический диск|Удалить шапку|Удалить пустые строки|Удалить пробелы в конце строки и каретку \r|Подстановка макроса|зыкрытие }, кроме последней строки| закрытие последней строки}
DISKNUM=$(zabbix_get -s $1 -k system.run["WMIC.exe /NAMESPACE:\\\root\CIMV2 PATH win32_PerfFormattedData_PerfDisk_PhysicalDisk GET Name"]|sed -e '/Name/d'|sed -e '/^$/d'| sed 's/[ ]*\r//'|sed 's/^/\t{\"{#DISKNUMLET}\":\"/'|sed '$!s/.$/\"},/'|sed '${s/$/\"}/}')

# Вариант с портом
#DISKNUM=$(zabbix_get -s $1 -p $3 -k system.run["WMIC.exe /NAMESPACE:\\\root\CIMV2 PATH win32_PerfFormattedData_PerfDisk_PhysicalDisk GET Name"]|sed -e '/Name/d'|sed -e '/^$/d'| sed 's/[ ]*\r//'|sed 's/^/\t{\"{#DISKNUMLET}\":\"/'|sed '$!s/.$/\"},/'|sed '${s/$/\"}/}')

#echo "${DISKNUM}"

# Проверка что ответ не пустой или не ошибка, если пусто то отправляем _Total
if [ -z "${DISKNUM}" ]; then DISKNUM={"{#DISKNUMLET}":"_Total"}
elif [[ "${DISKNUM}" =~ ZBX_NOTSUPPORTED|Timeout|ERROR|WMIC ]]; then DISKNUM={"{#DISKNUMLET}":"_Total"}
fi

#case $DISKNUM in
#        *ZBX_NOTSUPPORTED*|*Timeout*)
#         DISKNUM={"{#DISKNUMLET}":"_Total"}
#         ;;
#esac

# Формируе Вывод
JSONPHY="[\n"$DISKNUM"\n]"
echo -e "${JSONPHY}"
fi


if [[ $2 = "discovery.logical" ]]
then

# Список Физический/Логический диск|Удалить шапку|Удаление номеров дисков|Удаление пробелов и каретки \r|Диски по строкам|Удаление пустых строк|Подстановка макроса|зыкрытие }, кроме последней строки| закрытие последней строки}
FSNAME=$(zabbix_get -s $1 -k system.run["WMIC.exe /NAMESPACE:\\\root\CIMV2 PATH win32_PerfFormattedData_PerfDisk_PhysicalDisk GET Name"]|sed -e '/Name/d'|sed 's/^[0-9] *//'|tr -d ' \r'|sed 's/:/:\n/g'|sed -e '/^$/d'| sed 's/^/\t{\"{#FSNAME}\":\"/'|sed '$!s/$/\"},/'|sed '${s/$/\"}/}')


# Вариант с портом
#FSNAME=$(zabbix_get -s $1 -p $3 -k system.run["WMIC.exe /NAMESPACE:\\\root\CIMV2 PATH win32_PerfFormattedData_PerfDisk_PhysicalDisk GET Name"]|sed -e '/Name/d'|sed 's/^[0-9] *//'|tr -d ' \r'|sed 's/:/:\n/g'|sed -e '/^$/d'| sed 's/^/\t{\"{#FSNAME}\":\"/'|sed '$!s/$/\"},/'|sed '${s/$/\"}/}')

# Проверка что ответ не пустой или не ошибка, если пусто то отправляем _Total
if [ -z "${FSNAME}" ]; then FSNAME={"{#FSNAME}":"_Total"}
elif [[ "${FSNAME}" =~ ZBX_NOTSUPPORTED|Timeout|ERROR|WMIC ]]; then FSNAME={"{#FSNAME}":"_Total"}
fi

# Формируе Вывод
JSONLOG="[\n"$FSNAME"\n]"
echo -e "${JSONLOG}"
fi