#!/bin/bash
#2021/08/04 v1.0
# Автор Мамзиков Артём Андреевич Описание по скрипту
# Получение списка Дисков Linux до версии zabbix 4.4 есть ключ vfs.dev.discovery

#./vfs.dev.sh 192.168.xxx.xxx 10050 discovery ".*" "^$", ключ vfs.dev.sh[{HOST.CONN},{$HOST.PORTS},discovery,{$DISKFILTRL},{$DISKHIDEL}]

# Объявим входные переменные(variable) и если входная переменная пустая задаем дефолтные настройки для некоторых переменных
IP=$1
PORT=${2:-10050}
BLOCSCRIPT=$3
FILTR=${4:-.*}
HIDE=${5:-^$}

# Для построчного цикла
IFS=$'\n'

if [[ $BLOCSCRIPT = "discovery" ]]
then
#Вариант получения только списка дисков
#get=`zabbix_get -s $1 -k system.run["ls -F /sys/class/block/|grep -E \"*/|@\"|tr -d '@'"]`

# Запрос Дисков | Убрать 1 строку|Убираем символы таблицы
#get=`zabbix_get -s $IP -p $PORT -k system.run["lsblk 2>/dev/null|awk NR\>1|tr -d '├─'|tr -d '│└─' |tr -d '|-'"]`
# Разберем символы в начале строки и уберем их, берем значение в скобках если есть
get=$(zabbix_get -s $IP -p $PORT -k system.run["lsblk 2>/dev/null|awk NR\>1|sed -e's/├─//;s/│└─//;s/│//;s/└─//;s/|-//;s/^ *//;s/\`//;s/^-//g'|sed -e 's/.*(\|)//g'"])
# Добавим фильтра
diski=$(echo "${get}" |sed -n '/'$FILTR'/Ip'|sed -e '/'$HIDE'/d')

fi

# Цикл Перебор строк в переменную data
for data in $diski
do
# Выбираем необходимые данные
NAME=$(echo "${data}"|awk '{print $1}')
TYPE=$(echo "${data}"|awk '{print $6}')
MOUNT=$(echo "${data}"|awk '{print $7}')
# Формируем вывод
JSON=$JSON"$SEP\n{\"{#DEVNAME}\":\"$NAME\", \"{#DEVTYPE}\":\"$TYPE\", \"{#DEVMOUNT}\":\"$MOUNT\"}"
SEP=", "
done
# Выводим результат в json data
JSON="["$JSON"\n]"
echo -e $JSON
